// RUN: %dxc -T lib_6_5 %s | %D3DReflect %s | FileCheck %s

// CHECK:DxilRuntimeData (size = 220 bytes):
// CHECK:  StringBuffer (size = 28 bytes)
// CHECK:  IndexTable (size = 12 bytes)
// CHECK:  RawBytes (size = 0 bytes)
// CHECK:  RecordTable (stride = 32 bytes) ResourceTable[2] = {
// CHECK:    <0:RuntimeDataResourceInfo> = {
// CHECK:      Class: SRV
// CHECK:      Kind: TypedBuffer
// CHECK:      ID: 0
// CHECK:      Space: 0
// CHECK:      LowerBound: 1
// CHECK:      UpperBound: 1
// CHECK:      Name: "inputs"
// CHECK:      Flags: 0 (None)
// CHECK:    }
// CHECK:    <1:RuntimeDataResourceInfo> = {
// CHECK:      Class: UAV
// CHECK:      Kind: TypedBuffer
// CHECK:      ID: 0
// CHECK:      Space: 0
// CHECK:      LowerBound: 1
// CHECK:      UpperBound: 1
// CHECK:      Name: "g_Intensities"
// CHECK:      Flags: 0 (None)
// CHECK:    }
// CHECK:  }
// CHECK:  RecordTable (stride = 44 bytes) FunctionTable[1] = {
// CHECK:    <0:RuntimeDataFunctionInfo> = {
// CHECK:      Name: "main"
// CHECK:      UnmangledName: "main"
// CHECK:      Resources: <0:RecordArrayRef<RuntimeDataResourceInfo>[2]>  = {
// CHECK:        [0]: <0:RuntimeDataResourceInfo>
// CHECK:        [1]: <1:RuntimeDataResourceInfo>
// CHECK:      }
// CHECK:      FunctionDependencies: <string[0]> = {}
// CHECK:      ShaderKind: Compute
// CHECK:      PayloadSizeInBytes: 0
// CHECK:      AttributeSizeInBytes: 0
// CHECK:      FeatureInfo1: 0
// CHECK:      FeatureInfo2: 0
// CHECK:      ShaderStageFlag: 32
// CHECK:      MinShaderTarget: 327776
// CHECK:    }
// CHECK:  }
// CHECK:ID3D12LibraryReflection:
// CHECK:  D3D12_LIBRARY_DESC:
// CHECK:    Creator: <nullptr>
// CHECK:    Flags: 0
// CHECK:    FunctionCount: 1
// CHECK:  ID3D12FunctionReflection:
// CHECK:    D3D12_FUNCTION_DESC: Name: main
// CHECK:      Shader Version: Compute 6.5
// CHECK:      Creator: <nullptr>
// CHECK:      Flags: 0
// CHECK:      ConstantBuffers: 0
// CHECK:      BoundResources: 2
// CHECK:      FunctionParameterCount: 0
// CHECK:      HasReturn: FALSE
// CHECK:    Bound Resources:
// CHECK:      D3D12_SHADER_INPUT_BIND_DESC: Name: inputs
// CHECK:        Type: D3D_SIT_TEXTURE
// CHECK:        uID: 0
// CHECK:        BindCount: 1
// CHECK:        BindPoint: 1
// CHECK:        Space: 0
// CHECK:        ReturnType: D3D_RETURN_TYPE_SINT
// CHECK:        Dimension: D3D_SRV_DIMENSION_BUFFER
// CHECK:        NumSamples (or stride): 4294967295
// CHECK:        uFlags: 0
// CHECK:      D3D12_SHADER_INPUT_BIND_DESC: Name: g_Intensities
// CHECK:        Type: D3D_SIT_UAV_RWTYPED
// CHECK:        uID: 0
// CHECK:        BindCount: 1
// CHECK:        BindPoint: 1
// CHECK:        Space: 0
// CHECK:        ReturnType: D3D_RETURN_TYPE_SINT
// CHECK:        Dimension: D3D_SRV_DIMENSION_BUFFER
// CHECK:        NumSamples (or stride): 4294967295
// CHECK:        uFlags: 0

struct Foo {
    int a[2];
    int d[2];
};

Buffer<Foo> inputs : register(t1);
RWBuffer< int > g_Intensities : register(u1);

groupshared Foo sharedData;

[ numthreads( 64, 2, 2 ) ]
void main( uint GI : SV_GroupIndex)
{
  if (GI==0)
	sharedData = inputs[GI];
	int rtn;
	InterlockedAdd(sharedData.d[0], g_Intensities[GI], rtn);
	g_Intensities[GI] = rtn + sharedData.d[0];
}